/*

  This file is part of HOTSPOTS.DLL source code, see MAIN.C for
  detailed information.

  Copyright (C) 2000-2001 Pavel Vitis
  pavel.vitis@seznam.cz
  http://lsg.come.to/


  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/****************************************************************************
****************************************************************************/

#include "../lsapi/lsapi.h"
#include "../kmhook/hookdll.h"
#include "main.h"

void bangModEnable(HWND caller, char *args)
{
	mod_enabled = TRUE;
}

void bangModDisable(HWND caller, char *args)
{
	mod_enabled = FALSE;
}

void bangModToggle(HWND caller, char *args)
{
	mod_enabled = !mod_enabled;
}

void bangHotspotUpdate(HWND caller, char *args)
{
	updateHotspot(args);
}

void bangHotspotEnable(HWND caller, char *args)
{
	enableHotspot(args, TRUE);
}

void bangHotspotDisable(HWND caller, char *args)
{
	enableHotspot(args, FALSE);
}

/*
{$IFDEF SHOWLIST}
procedure BangShowList(Caller:HWnd;Args:pchar); cdecl;
var
  I:word;
  BufPos:PChar;
  Buffer:PChar;
  Flg:string;
const
  BufSize = 4*1024;
begin
{$IFDEF LOG}
  Log('!HotspotsList');
{$ENDIF}
  Buffer:=AllocMem(BufSize);
  if Buffer = nil then
    exit;
  if HotspotsList = nil then
  begin
    ShowError('Information', 'No known hotspots.', '', '');
    exit;
  end;
  Buffer[0]:=#0;
  BufPos:=Buffer;
  For I:=1 to HotspotsCount do
  begin

    with HotspotsList^[I] do
    begin
      Flg:='';
      if Flags.Disabled then
        Flg:=FL_DISABLED;
      if Flags.Silent then
        Flg:=Flg+FL_SILENT;
      if Flags.Maximized then
        Flg:=Flg+FL_MAXIMIZED;
      if Flags.Minimized then
        Flg:=Flg+FL_MINIMIZED;
      if Flags.Restore then
        Flg:=Flg+FL_RESTORE;
      if Flags.Toggle then
        Flg:=Flg+FL_TOGGLE;
      if Flags.ConsumeClick then
        Flg:=Flg+FL_CONSUMECLICK;
      if Flags.OneInstance then
        Flg:=Flg+FL_ONEINSTANCE;
      if Flags.EnabledInFullScreen then
        Flg:=Flg+FL_ENABLEDINFULLSCREEN;
      StrFmt(BufPos, '%s:  F:%s  X:%d  Y:%d  W:%d  H:%d  D:%d  M:''%s''  C:''%s''  AI:''%s'''#13,
        [Name, Flg, Origin.X, Origin.Y, Size.X, Size.Y, Delay, ModuleName, ClassName, ActionIn]);
    end;
    BufPos:=StrEnd(BufPos);
//    if BufPos - Buffer > BufSize - 255 then
//      break;
  end;
  MessageBox(GetLitestepWnd, Buffer, 'Hotspots list', MB_OK or MB_TOPMOST);
  FreeMem(Buffer, BufSize);
{$IFDEF LOG}
  Log('!HotspotsList end');
{$ENDIF}
end;
{$ENDIF}

procedure BangSystemBeep(Caller:HWnd;Args:pchar); cdecl;
begin
  SysUtils.beep;
end;
*/
/*
void BangHookDLLVersion(HWND caller, char *args)
{
	char msgbuf[5];
	WORD v;

	LOG("BangHookDLLVersion()");

	v = getHookDLLVersion();

	if ( v == 0 )
		MessageBox(NULL, "Wrong version of " HOOK_DLL, ST_NAME, MB_OK | MB_ICONEXCLAMATION | MB_TOPMOST );
	else
	{
		sprintf(msgbuf, HOOK_DLL " version: %02d.%02d", LOBYTE(v), HIBYTE(v));
		MessageBox(NULL, msgbuf, ST_NAME, MB_OK | MB_ICONEXCLAMATION | MB_TOPMOST );
	}

	LOG("BangHookDLLVersion() end");
}
*/

void addBangs(void)
{
	AddBangCommand("!HotspotsEnable", bangModEnable);
	AddBangCommand("!HotspotsDisable", bangModDisable);
	AddBangCommand("!HotspotsToggle", bangModToggle);
	AddBangCommand("!HotspotUpdate", bangHotspotUpdate);
	AddBangCommand("!HotspotEnable", bangHotspotEnable);
	AddBangCommand("!HotspotDisable", bangHotspotDisable);
//	AddBangCommand("!KMHookDLLVersion", BangHookDLLVersion);
//	AddBangCommand("!SystemBeep", BangSystemBeep);
}

void removeBangs(void)
{
	RemoveBangCommand("!HotspotsEnable");
	RemoveBangCommand("!HotspotsDisable");
	RemoveBangCommand("!HotspotsToggle");
	RemoveBangCommand("!HotspotUpdate");
	RemoveBangCommand("!HotspotEnable");
	RemoveBangCommand("!HotspotDisable");
//	RemoveBangCommand("!KMHookDLLVersion");
//	RemoveBangCommand("!SystemBeep");
}
