/*

  This file is part of HOTSPOTS.DLL source code, see MAIN.C for
  detailed information.

  Copyright (C) 2000-2001 Pavel Vitis
  pavel.vitis@seznam.cz
  http://lsg.come.to/


  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/****************************************************************************
****************************************************************************/

#include <windows.h>
#include <mmsystem.h>
#include <commctrl.h>
#include "../kmhook/hookdll.h"
#include "../lsapi/lsapi.h"
#include "main.h"

//static HWND parent_window = NULL;

static UINT nMessages[] = {
	LM_GETREVID,
	0
};

//HCURSOR oldCur = NULL;

/*
void sound( LPCTSTR snd, LPCTSTR def )
{
	if ( snd )
		sndPlaySound( snd, SND_ASYNC | SND_NOSTOP );
	else
	if ( def )
		sndPlaySound( def, SND_ASYNC | SND_NOSTOP );
}


void cancelMode( HWND wnd )
{
	char classbuf[256];
	HWND twnd;

	twnd = wnd;
	do {
		SendMessage(twnd, WM_CANCELMODE, 0, 0);
		SendMessage(twnd, WM_CAPTURECHANGED, 0, 0);
		twnd = GetWindow(twnd, GW_HWNDPREV);
	} while ( twnd && (twnd != wnd) );

	twnd = GetWindow(wnd, GW_HWNDFIRST);
	PostMessage(GetWindow(twnd, GW_OWNER), WM_CANCELMODE, 0, 0);
	PostMessage(GetWindow(twnd, GW_OWNER), WM_CAPTURECHANGED, 0, 0);

	PostMessage(GetWindow(wnd, GW_OWNER), WM_CANCELMODE, 0, 0);
	PostMessage(GetWindow(wnd, GW_OWNER), WM_CAPTURECHANGED, 0, 0);

	if ( twnd = GetParent(wnd) )
	{
		SendMessage(twnd, WM_CANCELMODE, 0, 0);
		SendMessage(twnd, WM_CAPTURECHANGED, 0, 0);
	}

	if ( twnd = GetCapture() )
	{
		SendMessage(twnd, WM_CANCELMODE, 0, 0);
		SendMessage(twnd, WM_CAPTURECHANGED, 0, 0);
	}


/*	if ( GetClassName(twnd, classbuf, sizeof(classbuf)) )
	{
		if ( strcmp("#32768", classbuf) == 0 )
		{
			PostMessage(GetWindow(twnd, GW_OWNER), WM_CANCELMODE, 0, 0);
//			PostMessage(twnd, WM_CLOSE, 0, 0);
			#ifdef LOGGING
			OutputDebugString("Menu cancelled");
			#endif
		}
	}
	*
}
*/

static DWORD LBTicks = 0;
static BYTE LBDBLSequence = 0;
static DWORD RBTicks = 0;
static BYTE RBDBLSequence = 0;
static DWORD MBTicks = 0;
static BYTE MBDBLSequence = 0;

// We should handle doubleclicks at our own, because system does not
// send WM_xxxDBLCLK messages to windows which do not have CS_DBLCLKS
// style flag set.
//
// returns unchanged wParam if no doubleclick,
// or changed to WM_xBUTTONDBLCLKS if doubleclick detected (x = L,R,M)

WPARAM GetDoubleClick( WPARAM wParam )
{

// define nasty coding-shortcut:
#define DOCASE(KEY)	\
	case WM_ ## KEY ## BUTTONDOWN:								\
	case WM_NC ## KEY ## BUTTONDOWN:							\
		if ( KEY ## BDBLSequence == 0 )	{						\
			KEY ## BTicks = GetTickCount();						\
			KEY ## BDBLSequence = 1;							\
		} 														\
		else 													\
		if ( KEY ## BDBLSequence == 2 ) {						\
			if ( GetTickCount() - KEY ## BTicks < DoubleClickTime )	{ \
				wParam = WM_ ## KEY ## BUTTONDBLCLK;			\
				KEY ## BDBLSequence = 0;						\
			} else {											\
				KEY ## BTicks = GetTickCount();					\
				KEY ## BDBLSequence = 1;						\
			}													\
		}														\
		else													\
			KEY ## BDBLSequence = 0;							\
		break;													\
	case WM_ ## KEY ## BUTTONUP:								\
	case WM_NC ## KEY ## BUTTONUP:								\
		if ( KEY ## BDBLSequence == 1 )	{						\
			if ( GetTickCount() - KEY ## BTicks < DoubleClickTime ) \
				KEY ## BDBLSequence = 2;						\
			else												\
				KEY ## BDBLSequence = 0;						\
		}														\
		break;													\


	// check every mouse button messages
	switch (wParam)
	{
		DOCASE(L)
		DOCASE(R)
		DOCASE(M)
	}

	return wParam;
}

LRESULT WINAPI WndProc( HWND hWnd, UINT nMessage, WPARAM wParam, LPARAM lParam )
{
	char pszBuf[256];

	#define MHSTRUCT ((PMOUSEHOOKSTRUCT) lParam)

	// MouseMsg message comes from KMHOOK.DLL - System wide mouse hook.
	// Mouse hook procedure in KMHOOK.DLL is waiting for our return parameter,
	// so we should keep this sections tiny and fast.
	// If we return 1, mouse click will be "consumed" and no window will see it:
	if ( nMessage == MouseMsg )
	{
		// Not used yet, maybe use for updating mouse coordinates elsewhere in code:
		if ( (wParam == WM_MOUSEMOVE) || (wParam == WM_NCMOUSEMOVE) )
		{
			mousepos = MHSTRUCT->pt;
		}
		else
		// We have received some mouse-click message
		{
			// Try to transform wParam into WM_xxxDBLCLK message, if there was double-click:
			wParam = GetDoubleClick(wParam);

			// If we have some hotspot active, we should handle its mouse-click actions now:
			if (last_hotspot != NO_HOTSPOT)
			{
				if ( performClickAction(wParam, MHSTRUCT->dwExtraInfo, MAKELPARAM(MHSTRUCT->pt.x, MHSTRUCT->pt.y)) != 0 )
				{
					// If action returned TRUE ("consume-mouse-click" flag was set), we should swallow
					// that message, so we return 1 to KMHOOK.DLL mouse-hook function here:
					return 1;
				}
			}
		}

		// In any other case, let the mouse message fly into system queue
		return 0;
	}


	switch( nMessage )
	{
		// Not used now, TimerProc is called directly from timer, there is more precisely timing then
		case WM_TIMER:
//			timerProc();
			return 0;
			break;
		// Window create ok
		case WM_CREATE:
			return 0;
			break;
		// Don't erase background
		case WM_ERASEBKGND:
			#ifdef PAINT_HOTSPOT
			paintWnd(hWnd);
			#endif
			return 0;
			break;
		// No drawing, please
		case WM_PAINT:
			#ifdef PAINT_HOTSPOT
			paintWnd(hWnd);
			#endif
			return 0;
			break;
		// These cases should not occur
		case WM_KEYDOWN:
//			PostMessage(parent,msg,wParam,lParam);
//			return 0;
			break;
		case WM_KEYUP:
//			PostMessage(parent,msg,wParam,lParam);
//			return 0;
			break;
		// Return module version number and revision
		case LM_GETREVID:
			if( wParam == 0 || wParam == 1 )
				strcpy( pszBuf, ST_REVID );
			else
				pszBuf[0] = 0;
			return strlen( pszBuf );
	}

	return DefWindowProc( hWnd, nMessage, wParam, lParam );
}


BOOL createToolWindow( void )
{
	WNDCLASS wc;

	// register main window class
	memset(&wc, 0, sizeof(wc));
	wc.style = CS_DBLCLKS | CS_NOCLOSE;
	wc.lpfnWndProc = (WNDPROC) WndProc;
	wc.hInstance = DLLInstance;
	wc.lpszClassName = WC_MAIN;

//	LOGF("DLLInst: %x", DLLInstance);

	if (RegisterClass(&wc) == 0)
	{
		LOGLE;
		return FALSE;
	}

//	LOG("Tool window class registered");

	// create invisible tool window
	tool_window = CreateWindowEx(
		WS_EX_NOPARENTNOTIFY | WS_EX_TOOLWINDOW | WS_EX_TRANSPARENT,
		WC_MAIN,
		NULL,
		WS_POPUP,
		0,
		0,
		0,
		0,
		NULL,
		0,
		DLLInstance,
		NULL );

	if (tool_window == NULL)
	{
		UnregisterClass( WC_MAIN, DLLInstance );
		return FALSE;
	}

//	LOG("Tool window created");

	// hide us from the VWM and set initial visibility state
	SetWindowLong( tool_window, GWL_USERDATA, magicDWord );
	SetParent( tool_window, hLitestep );

	// register for messages from the LS core
	SendMessage( hLitestep, LM_REGISTERMESSAGE, (WPARAM) tool_window, (LPARAM) nMessages );

	return TRUE;
}

void destroyToolWindow( void )
{
	SendMessage( hLitestep, LM_UNREGISTERMESSAGE, (WPARAM) tool_window, (LPARAM) nMessages );
	DestroyWindow( tool_window );
	UnregisterClass( WC_MAIN, DLLInstance );
}
